## castle-model-viewer 5.2.0

=== Makefile ===
# build / clean --------------------------------------------------------------

# Hint: use
#   export CASTLE_ENGINE_TOOL_OPTIONS='--mode=debug'
#   make
# to build in debug mode.

.PHONY: compile
compile:
	./compile.sh

.PHONY: clean
clean:
	castle-engine clean
	castle-engine clean --manifest-name=CastleEngineManifest.converter.xml
# remove also macOS stuff
	rm -Rf castle-model-viewer.app \
	       castle-model-converter.app \
	       macosx/castle-model-viewer.app \
	       macosx/castle-model-converter.app \
	       macosx/*.dmg

# install / uninstall --------------------------------------------------------
#
# By default castle-model-viewer is installed system-wide to /usr/local .
# You can run "make" followed by "sudo make install" to have it
# ready on a typical Unix system.

# Standard installation dirs, following conventions on
# http://www.gnu.org/prep/standards/html_node/Directory-Variables.html#Directory-Variables
PREFIX=$(DESTDIR)/usr/local
EXEC_PREFIX=$(PREFIX)
BINDIR=$(EXEC_PREFIX)/bin
DATAROOTDIR=$(PREFIX)/share
DATADIR=$(DATAROOTDIR)

.PHONY: install
install:
	install -d $(BINDIR)
	install castle-model-viewer $(BINDIR)
	install castle-model-converter $(BINDIR)
	install -d  $(DATADIR)
	cd freedesktop/ && ./install.sh "$(DATADIR)"

.PHONY: uninstall
uninstall:
	rm -f $(BINDIR)/castle-model-viewer \
	      $(BINDIR)/castle-model-converter
	cd freedesktop/ && ./uninstall.sh "$(DATADIR)"

# code generation ------------------------------------------------------------

# Run a couple of child targets to autogenerate some code
.PHONY: generate-code
generate-code:
	$(MAKE) -C embedded_data/images/
	$(MAKE) -C embedded_data/screen_effects/

# Clean autogenerated code
.PHONY: clean-code
clean-code:
	$(MAKE) -C embedded_data/images/ clean
	$(MAKE) -C embedded_data/screen_effects/ clean

=== embedded_data/Makefile ===
default:
	$(MAKE) -C designs/
	$(MAKE) -C images/
	$(MAKE) -C opaque_images/
	$(MAKE) -C scenes/
	$(MAKE) -C screen_effects/

clean:
	$(MAKE) -C designs/ clean
	$(MAKE) -C images/ clean
	$(MAKE) -C opaque_images/ clean
	$(MAKE) -C scenes/ clean
	$(MAKE) -C screen_effects/ clean

=== freedesktop/Makefile ===
# See INSTALL file for some comments about installing desktop data.

APP_NAME := castle-model-viewer

APP_ICON := ../../www/logo/6_thicker.svg

ALL_IMAGES := $(APP_NAME).png $(APP_NAME).svg $(APP_NAME).icns

.PHONY: all_images
all_images: $(ALL_IMAGES)

# Copy/convert $(APP_ICON) to nice names, in svg and (48x48) png.
$(APP_NAME).svg: $(APP_ICON)
	cp -f $< $@

$(APP_NAME).png: $(APP_ICON)
	inkscape --export-width=48 --export-height=48 $< --export-png=$@

$(APP_NAME).icns: $(APP_ICON)
	../../scripts/svg_to_icns.sh $< $@

=== embedded_data/images/Makefile ===
# Process all *.png images in this directory to Pascal,
# preserving alpha channel.

.PHONY: all clean

ALL_UNITS=../../code/v3dsceneimages.pas

all: $(ALL_UNITS)

clean:
	rm -f $(ALL_UNITS)

$(ALL_UNITS): *.png
	image-to-pascal --output ../../code V3DSceneImages *.png

=== embedded_data/opaque_images/Makefile ===
# Process all *.png images in this directory to Pascal,
# stripping alpha channel.

.PHONY: all clean

ALL_UNITS=../../code/v3dsceneopaqueimages.pas

all: $(ALL_UNITS)

clean:
	rm -f $(ALL_UNITS)

$(ALL_UNITS): *.png
	image-to-pascal --output ../../code V3DSceneOpaqueImages @alpha=strip *.png

=== embedded_data/scenes/Makefile ===
# This requires file_to_pascal_string from PasDoc
# ( https://github.com/pasdoc/pasdoc/wiki ) project. Get it and compile from
# https://raw.githubusercontent.com/pasdoc/pasdoc/master/source/tools/file_to_pascal_string.dpr .

ALL_TARGETS := welcome_scene.inc clear_scene.inc

default: $(ALL_TARGETS)

clean:
	rm -f $(ALL_TARGETS)

%.inc: %.wrl
	file_to_pascal_string $< $@

=== embedded_data/screen_effects/Makefile ===
# This requires file_to_pascal_string from PasDoc
# ( https://github.com/pasdoc/pasdoc/wiki ) project. Get it and compile from
# https://raw.githubusercontent.com/pasdoc/pasdoc/master/source/tools/file_to_pascal_string.dpr .

ALL_ORIGINAL := $(wildcard *.x3dv)
ALL_TARGETS := $(subst .x3dv,.x3dv.inc,$(ALL_ORIGINAL))

default: $(ALL_TARGETS)

clean:
	rm -f $(ALL_TARGETS)

%.x3dv.inc: %.x3dv
	file_to_pascal_string $< $@

=== doc/man/man1/Makefile ===
.PHONY: all
all: castle-model-viewer.1 castle-model-converter.1

castle-model-viewer.1: castle-model-viewer.adoc
	asciidoctor -b manpage castle-model-viewer.adoc

castle-model-converter.1: castle-model-converter.adoc
	asciidoctor -b manpage castle-model-converter.adoc

=== debian/changelog ===
castle-model-viewer (5.2.0-3) unstable; urgency=medium

  * Enabled hardening using FPC hardening configuration file.
  * Bumped standard version.
  * Removed few Lintian comments on control file.
  * Enabled Static-Built-Using stanza in control file.
    This should trigger rebuild of CMV in case of security fixes to FPC RTL
    and other changes in statically linked  libraries. (Closes: Bug#1095334)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 09 Feb 2025 01:20:13 +0100

castle-model-viewer (5.2.0-2) unstable; urgency=medium

  * Fixed Lintian warning about alien tag.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Fri, 31 Jan 2025 21:44:07 +0100

castle-model-viewer (5.2.0-1) unstable; urgency=medium

  * Updated watch file for new version with new sources name.
    View3DScene is now renamed Castle Model View by upstream.
  * New upstream version 5.2.0
  * Updated patches to fit new upstream source files.
  * Renamed package name and added transitional package.
    Renamed also related installation files.
  * Updated rules file to compile new programs and updated install file.
    Use upstream make file to build programs and rename executable files.
  * Renamed source package to fit new upstream name.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Mon, 06 Jan 2025 22:34:55 +0100

view3dscene (4.2.0-4) unstable; urgency=medium

  * Remove dependency on gtkglext (Unblocks: #967491 #1054392)
  * Update patch header (forwarded)
  *  Allow for missing file in clean target

 -- Peter Blackman <peter@pblackman.plus.com>  Tue, 31 Oct 2023 14:00:00 +0000

view3dscene (4.2.0-3) unstable; urgency=medium

  * Re-enable lto with fix (thanks Graham Inggs)
  * Fixes FTBFS on Ubuntu

 -- Peter Blackman <peter@pblackman.plus.com>  Mon, 02 Oct 2023 18:00:00 +0100

view3dscene (4.2.0-2) unstable; urgency=medium

  * Depend on libgl1 (Closes: #1051598)
  * Build-Depends on libgdk-pixbuf-2.0-dev (Closes: #1037406)
  * Disable lto (Closes: #1015702)
  * Fix links in debian/copyright
  * Fix folder name in debian/clean
  * Drop build dependency on whitedune-docs
  * Add lintian overrides
  * Add myself to Uploaders
  * Update standards version to 4.6.2, no changes needed.

 -- Peter Blackman <peter@pblackman.plus.com>  Tue, 19 Sep 2023 21:00:00 +0100

view3dscene (4.2.0-1) unstable; urgency=medium

  * Updated gbp import filter to exclude automatically generated files.
  * New upstream version 4.2.0 (Closes: Bug#1022343)
  * Updated Debian build rules and patches to fit new release changes.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 06 Nov 2022 18:54:46 +0100

view3dscene (4.0.0-3) unstable; urgency=medium

  * Updated build script to use CGE units new installation directory.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 06 Feb 2022 22:22:19 +0100

view3dscene (4.0.0-2) unstable; urgency=medium

  * Added recommend dependency on sensible-utils package advised by Lintian.
  * Dropped optional license not yet agreed to be DFSG compatible.
  * Filter out auto-generated files upon source import.

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sun, 07 Nov 2021 15:46:28 +0100

view3dscene (4.0.0-1) stable; urgency=medium

  [ Jenkins ]
  * Update watch file format version to 4.
    Changes-By: lintian-brush
    Fixes: lintian: older-debian-watch-file-standard
    See-also:
      https://lintian.debian.org/tags/older-debian-watch-file-standard.html
  * Update standards version to 4.5.1, no changes needed.
    Changes-By: lintian-brush
    Fixes: lintian: out-of-date-standards-version
    See-also: https://lintian.debian.org/tags/out-of-date-standards-version.html

  [ Abou Al Montacir ]
  * Fixed watch file after upstream URL changed.
  * Added GBP configuration file.
  * New upstream version 4.0.0
  * Fixed make clean target.
  * Fixed path of Castle Game Engine units. (Closes: Bug#997940)

 -- Abou Al Montacir <abou.almontacir@sfr.fr>  Sat, 06 Nov 2021 20:54:06 +0100

view3dscene (3.18.0-4) unstable; urgency=medium

  * Use --export-filename i.s.o. --export-png (Closes: #959610)
  * Bump debhelper compat to 13 (via debhelper-compat)
  * Bump standards
  * Drop versioned B-D fp-utils, even jessie has higher

 -- Paul Gevers <elbrus@debian.org>  Wed, 06 May 2020 20:34:49 +0200

view3dscene (3.18.0-3) unstable; urgency=medium

  * Temporarily drop dependency on again kicad-common as that FTBFS (we
    don't need it, just nice to have)

 -- Paul Gevers <elbrus@debian.org>  Tue, 05 Jun 2018 21:10:40 +0200

view3dscene (3.18.0-2) unstable; urgency=medium

  * [tests] Only test on kicad-common on amd64 as it really takes long and
    currently prevents armel/armhf from building in time

 -- Paul Gevers <elbrus@debian.org>  Mon, 12 Feb 2018 22:46:30 +0100

view3dscene (3.18.0-1) unstable; urgency=medium

  * New upstream release
  * Drop B-D on cge-src as it isn't needed anymore (Closes: #751473)
  * Bump B-D on fp-units-castle-game-engine to prevent FTBFS
  * Bump standards to 4.1.3 (no changes)
  * Bump debhelper compat level to 11 and set Rules-Requires-Root to no
  * Migrate VCS fields to Salsa URL

 -- Paul Gevers <elbrus@debian.org>  Sun, 11 Feb 2018 20:42:40 +0100

view3dscene (3.17.0-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream release
  * Drop patches from upstream
  * Bump standards version to 4.0.0 (no changes)
  * Bump required version for castle-game-engine packages

 -- Paul Gevers <elbrus@debian.org>  Wed, 12 Jul 2017 21:46:04 +0200

view3dscene (3.16.1-1) experimental; urgency=medium

  * New upstream version 3.16.1
  * Bump required version for castle-game-engine packages
  * Update upstream homepage
  * Update d/copyright for new source
  * Drop and refresh patches based on new source code
  * Bump debhelper compat level
  * Generate input code and add file_to_pascal_string to do it
  * Add upstream add-keyword-to-desktop-file.patch
  * Drop lintian override, it isn't needed anymore
  * Enable bindnow in the linker flags


=== debian/control ===
Source: castle-model-viewer
Section: graphics
Priority: optional
Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
Uploaders:
 Abou Al Montacir <abou.almontacir@sfr.fr>,
 Paul Gevers <elbrus@debian.org>,
 Peter Blackman <peter@pblackman.plus.com>
Standards-Version: 4.7.0
Build-Depends:
 debhelper-compat (= 13),
 fp-compiler,
 fp-units-castle-game-engine,
 fp-units-fcl,
 fp-units-gfx,
 fp-units-gtk2,
 fp-units-net,
 fp-utils,
 inkscape (>= 1.0~),
 libatk1.0-dev,
 libgdk-pixbuf-2.0-dev,
 libgtk2.0-dev,
 libpango1.0-dev,
 libx11-dev
Vcs-Git: https://salsa.debian.org/pascal-team/castle-model-viewer.git
Vcs-Browser: https://salsa.debian.org/pascal-team/castle-model-viewer
Homepage: https://castle-engine.io/castle-model-viewer
Rules-Requires-Root: no

Package: castle-model-viewer
Architecture: any
Static-Built-Using: ${fpc:Static-Built-Using}, castle-game-engine (= ${CGE:Version})
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libgl1,
 zlib1g
Recommends:
 libopenal1,
 libvorbisfile3,
 sensible-utils
Replaces: view3dscene (<< 5.0.0-1~)
Breaks: view3dscene (<< 5.0.0-1~)
Suggests:
 graphicsmagick-imagemagick-compat | imagemagick,
 libav-tools | ffmpeg
Description: VRML / X3D browser, and a viewer for other 3D model formats
 Castle Model Viewer (CMV) is a viewer for many 3D model formats:
  - X3D
  - VRML (1.0 and 2.0, aka VRML 97)
  - Collada
  - OpenInventor
  - 3DS
  - MD3
  - Wavefront OBJ
  - Videoscape GEO
  - KAnim (Castle Game Engine animations)
 .
 Various navigation modes are available, like Examine, Walk (with gravity), Fly.
 Collision detection is done. Models can be animated and interactive. Many
 graphic effects are possible, thanks to using Castle Game Engine underneath.
 .
 CMV may also be used to convert many 3D model formats to X3D
 (in classic and XML encoding). This package includes also a command-line
 castle-model-converter program, that performs the same conversions as CMV,
 but doesn't use X or OpenGL (so it's nice to use in scripts to convert
 3D models in batch mode).

Package: view3dscene
Depends: castle-model-viewer, ${misc:Depends}
Architecture: all
Section: oldlibs
Description: Transitional package to castle-model-viewer
 This is a transitional package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS := hardening=+all
export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
export LANG:=C

include /usr/share/dpkg/pkg-info.mk

# Get Debian package version
DPKG_QUERY_OPTS= --show --showformat='$${version}'
DEB_PKG_VERSION=$(call dpkg_late_eval,$1, dpkg-query ${DPKG_QUERY_OPTS} $2)

# Set CGE version
CGE_VER=$(call DEB_PKG_VERSION,CGE_VER,fp-units-castle-game-engine)

# Get directories
CURDIR:=$(shell pwd)
TMP_DIR=$(CURDIR)/debian/tmp

# Set default compilation options
BUILDOPTS=\
	--compiler-option=@castle-game-engine \
	--compiler-option=@hardening \

%:
	dh ${@}

override_dh_auto_clean:
	dh_auto_clean -- -i
	$(MAKE) clean-code

override_dh_auto_build:override_dh_auto_build-arch override_dh_auto_build-indep
override_dh_auto_build-arch:
	mkdir -p $(TMP_DIR)

	# Once pasdoc ships file_to_pascal_string, the next lines can be simplified
	fpc -FE$(TMP_DIR) @hardening debian/file_to_pascal_string.dpr
	PATH=${PATH}:$(TMP_DIR) $(MAKE) generate-code

	${MAKE} compile CASTLE_ENGINE_TOOL_OPTIONS='$(BUILDOPTS)'
	inkscape --export-width=48 --export-height=48 freedesktop/castle-model-viewer.svg \
		--export-filename=freedesktop/castle-model-viewer

override_dh_auto_build-indep:

override_dh_auto_test:
	# Code to run the package test suite.
	# We need the directories where the files to test are to be
	# writeable by the current (non-root) user. Copying them in
	# the current tree is the easiest way to accomplish that.
	#
	# TBD. New tests planned using castle-game-engine

override_dh_auto_install-arch:
	fpc-depends
	echo CGE:Version=${CGE_VER} >> debian/castle-model-viewer.substvars

override_dh_auto_install-indep:

lintian:
	lintian -I -i ../${DEB_SOURCE}_${DEB_VERSION}.dsc

=== debian/watch ===
version=4
opts=\
compression=xz,\
repack,\
repacksuffix=+dfsg,\
uversionmangle=s/-/~/,\
dversionmangle=s/\+dfsg(\d*)//,\
filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%castle-model-viewer-$1.tar.xz% \
	https://github.com/castle-engine/castle-model-viewer/tags \
	(?:.*?/)?v?@ANY_VERSION@\.tar\.gz debian
